import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.text.*;

/**
 * Write a description of class Space here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Space extends World
{
    private static final int SCREEN_WIDTH = 800;
    private static final int SCREEN_HEIGHT = 600;
    
    private static final int SCREEN_MULTIPLIER = 2;
    
    private static final int SPACE_DEPTH = 400;
    
    private static final int TOTAL_STARS = 200;
    
    private Star[] stars = new Star[TOTAL_STARS];
    
    private Background background = new Background();
    
    private Control control = new Control();
    
    /**
     * Constructor for objects of class Space.
     * 
     */
    public Space()
    {    
        super(SCREEN_WIDTH, SCREEN_HEIGHT, 1); 
        createStars();
        addObject(control,0,0);
    }
    
    private void setBlackBackground() {
        this.getBackground().drawImage(background.getImage(),0,0);
//        this.getBackground().setColor(Color.black);
//        this.getBackground().fill();
    }
    
    private void createStars() {
        for (int i=0; i<TOTAL_STARS; i++) {
            Star star = new Star(this.getBackground());
            initialiseStar(star);
            stars[i] = star;   
        }
    }
    
    public void act() {
        setBlackBackground();
        updateStarField();
        displayDashboard();
    }
    
    private void updateStarField() {
        for (int i=0; i<TOTAL_STARS; i++) {
            stars[i].update(control.getSpeed(), control.shouldFlicker());
        }
    }
    
    private void displayDashboard() {
        this.getBackground().setColor(Color.white);
        DecimalFormat df = new DecimalFormat("##.##");
        String velocityStatus = "Velocity ["+df.format(control.getSpeed())+"]";
        this.getBackground().drawString(velocityStatus,0,10);
    }
    
    public static void initialiseStar(Star _star) {  
        _star.setCoordinate(initialiseCoordinate());
        _star.setVelocity(initialiseVelocity());
    }
    
    public static Coordinate3d initialiseCoordinate() {
        int spaceWidth = SCREEN_WIDTH * SCREEN_MULTIPLIER;
        int spaceHeight = SCREEN_HEIGHT * SCREEN_MULTIPLIER;
        int cx = Greenfoot.getRandomNumber(spaceWidth)-(spaceWidth/2);
        int cy = Greenfoot.getRandomNumber(spaceHeight)-(spaceHeight/2);
        int cz = -Greenfoot.getRandomNumber(SPACE_DEPTH);
        return new Coordinate3d(cx,cy,cz);
    }

    public static Velocity3d initialiseVelocity() {
        float vx = 0.0f;
        float vy = 0.0f;
        float vz = (Greenfoot.getRandomNumber(30)+20) / 10.0f;
        if (vz==0.0f) vz=0.1f;
        return new Velocity3d(vx,vy,vz);
    }
    
    public static int getDepth() {
        return SPACE_DEPTH;
    }
}
