import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;

/**
 * Write a description of class Star here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Star 
{
    private GreenfootImage backgroundImage;
    private int screenWidth;
    private int screenHeight;

    private Coordinate3d coordinate;
    private Velocity3d velocity;
    
    public Star(GreenfootImage _backgroundImage) {
        backgroundImage = _backgroundImage;
        screenWidth = _backgroundImage.getWidth();
        screenHeight = _backgroundImage.getHeight();
    }
    
    public void update(float _speed, boolean _flicker) {
        coordinate.addZ(velocity.getZ()*_speed);        
        
        if (_speed<0) {
            if (coordinate.getZ() < -Space.getDepth()) {
                coordinate.setZ(0);
            }
        } else {
            if (coordinate.getZ() > 0) {                
                coordinate.setZ(-Space.getDepth());
            }
        }

        int x = calculateOnScreenXPosition(coordinate);
        int y = calculateOnScreenYPosition(coordinate);

        if (_speed < 1.5f && _speed > -1.5f) {      
            plotStar(x,y,_flicker);
        } else {
            Coordinate3d warpCoordinate = new Coordinate3d(coordinate.getXYZ());
            warpCoordinate.addZ(_speed*3);
            int xEnd = calculateOnScreenXPosition(warpCoordinate);
            int yEnd = calculateOnScreenYPosition(warpCoordinate);
            plotStar(x,y,xEnd,yEnd,_flicker);            
        }
    }
    
    
    public Coordinate3d getCoordinate() {
        return coordinate;
    }
    
    private int calculateOnScreenXPosition(Coordinate3d _coordinate) {
        return (int)(((_coordinate.getX() / _coordinate.getZ()) * 100.0f) + (screenWidth * 0.5f));
    }
    
    private int calculateOnScreenYPosition(Coordinate3d _coordinate) {
        return (int)(((_coordinate.getY() / _coordinate.getZ()) * 100.0f) + (screenHeight * 0.5f));
    }
    
    public void setCoordinate(Coordinate3d _coordinate) {
        coordinate = _coordinate;
    }
    
    public void setVelocity(Velocity3d _velocity) {
        velocity = _velocity;
    }

    private void plotStar(int _x, int _y, boolean _flicker) {        
        plotStar(_x,_y,_x,_y,_flicker);
    }
    
    private void plotStar(int _xStart, int _yStart, int _xEnd, int _yEnd, boolean _flicker) {        
        if (onScreen(_xStart, _yStart, _xEnd, _yEnd)) {
            if (_flicker) {
                int red = Greenfoot.getRandomNumber(255);
                int green = Greenfoot.getRandomNumber(255);
                int blue = Greenfoot.getRandomNumber(255);
                backgroundImage.setColor(new Color(red,green,blue));
            } else {
                backgroundImage.setColor(Color.white);
            }
            backgroundImage.drawLine(_xStart, _yStart, _xEnd, _yEnd);
        }
    }

    private boolean onScreen(int _xStart, int _yStart, int _xEnd, int _yEnd) {             
            if (_xStart>=0 && _yStart>=0 && _xEnd<screenWidth && _yEnd<screenHeight) {
                int lineLength = lineLength(_xStart,_yStart,_xEnd,_yEnd);
                if (lineLength<50) {
                    return true;
                }
            }
            return false;
    }
    
    public int lineLength(int _xStart, int _yStart, int _xEnd, int _yEnd) {
        double x1 = (double)Math.min(_xStart,_xEnd);
        double x2 = (double)Math.max(_xStart,_xEnd);
        double y1 = (double)Math.min(_yStart,_yEnd);
        double y2 = (double)Math.max(_yStart,_yEnd);
        double x = Math.pow(x2-x1,2);
        double y = Math.pow(y2-y1,2);
        return (int)(Math.sqrt(x+y));
    }
}
